<!DOCTYPE HTML SYSTEM>
<!-- Generated by Lisaac shorter / html style -->
<html>
<head>
<title>
Lisaac prototype interface
</title>
</head>
<body BGCOLOR="#FFFFFF">

 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
<br><br><strong><font color="#A020F0">Section</font></strong> <strong><font color="#A020F0">Header</font></strong>
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">name</font></strong>        := <a href="ARRAY3.html"><font color="#008000">ARRAY3</font></a>[<font color="#008000">E</font>];

  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">comment</font></strong>     :=<font color="#BC8F8F">" General prurpose, resizable, three dimensional array.."</font>;
    
<br><br><strong><font color="#A020F0">Section</font></strong> <strong><font color="#A020F0">Inherit</font></strong>
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">parent_collection3</font></strong>:<strong><font color="#A020F0">Expanded</font></strong> <a href="COLLECTION3.html"><font color="#008000">COLLECTION3</font></a>[<font color="#008000">E</font>];
  
<br><br><strong><font color="#A020F0">Section</font></strong> <strong><font color="#A020F0">Public</font></strong>
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">lower1</font></strong>:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>;
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">lower2</font></strong>:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>;
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">lower3</font></strong>:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>;
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">upper1</font></strong>:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>;
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">upper2</font></strong>:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>;
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">upper3</font></strong>:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>;
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">count1</font></strong>:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>;
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">count2</font></strong>:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>;
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">count3</font></strong>:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>;
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">count</font></strong>:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>;
  
<br><br><strong><font color="#A020F0">Section</font></strong> <a href="ARRAY3.html"><font color="#008000">ARRAY3</font></a>
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">storage</font></strong>:<a href="NATIVE_ARRAY.html"><font color="#008000">NATIVE_ARRAY</font></a>[<font color="#008000">E</font>];
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp  To store elements line by line.</font></strong></em>
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">capacity</font></strong>:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>;
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp  Number of elements in `storage'.</font></strong></em>
  
<br><br><strong><font color="#A020F0">Section</font></strong> <strong><font color="#A020F0">Public</font></strong>
  
  <br><font FACE="Sans-serif" color="#000000"><B></B></font>
  <br><font FACE="Sans-serif" color="#000000"><B> Creation / modification:</B></font>
  <br><font FACE="Sans-serif" color="#000000"><B> </B></font>
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">create</font></strong> (line_min, column_min, depth_min:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) 
  <strong><font color="#0000FF">to</font></strong> (line_max, column_max, depth_max:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) :<font color="#008000">SELF</font> <-
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp  Reset all bounds `line_minimum' / `line_maximum' / `column_minimum'</font></strong></em>
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp  `column_maximum' / `depth_min' and `depth_max' using arguments as</font></strong></em>
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp  new values. All elements are set to the default value of type E.</font></strong></em>
    
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">make</font></strong> (line_min, column_min, depth_min:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) <strong><font color="#0000FF">to</font></strong> (line_max, column_max, depth_max:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) <-
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp  Reset all bounds `line_minimum' / `line_maximum' / `column_minimum'</font></strong></em>
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp  `column_maximum' / `depth_min' and `depth_max' using arguments as</font></strong></em>
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp  new values. All elements are set to the default value of type E.</font></strong></em>
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">from_collection3</font></strong> model:<a href="COLLECTION3.html"><font color="#008000">COLLECTION3</font></a>[<font color="#008000">E</font>] <-
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">from_collection</font></strong> contents:<a href="COLLECTION.html"><font color="#008000">COLLECTION</font></a>[<font color="#008000">E</font>] 
  <strong><font color="#0000FF">size</font></strong> (line_min,column_min,depth_min:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) 
  <strong><font color="#0000FF">to</font></strong> (line_max,column_max,depth_max:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) <-
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp  Reset all bounds using `line_min', `line_max', `column_min',</font></strong></em>
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp  `column_max', `depth_min', and `depth_max'.</font></strong></em>
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp  Copy all elements of `contents', line by line into Current.</font></strong></em>
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">from_model</font></strong> model:<a href="COLLECTION.html"><font color="#008000">COLLECTION</font></a>[<a href="COLLECTION.html"><font color="#008000">COLLECTION</font></a>[<a href="COLLECTION.html"><font color="#008000">COLLECTION</font></a>[<font color="#008000">E</font>]]] <-
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp The `model' is used to fill line by line the COLLECTION3.</font></strong></em>
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp Assume all sub-collections of have the same indexing.</font></strong></em>
    
  <br><font FACE="Sans-serif" color="#000000"><B></B></font>
  <br><font FACE="Sans-serif" color="#000000"><B> Resizing:</B></font>
  <br><font FACE="Sans-serif" color="#000000"><B></B></font>
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">resize</font></strong> (line_min, column_min, depth_min:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) <strong><font color="#0000FF">to</font></strong> (line_max, column_max, depth_max:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) <-
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp  Resize bounds of the Current array</font></strong></em>
    
  <br><font FACE="Sans-serif" color="#000000"><B></B></font>
  <br><font FACE="Sans-serif" color="#000000"><B> Implementation of others feature from COLLECTION3:</B></font>
  <br><font FACE="Sans-serif" color="#000000"><B></B></font>
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">item</font></strong> (line, column, depth:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) :<font color="#008000">E</font> <-
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">put</font></strong> element:<font color="#008000">E</font> <strong><font color="#0000FF">to</font></strong> (line, column, depth:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) <-
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">force</font></strong> x:<font color="#008000">E</font> <strong><font color="#0000FF">to</font></strong> (line, column, depth:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) <-
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">set_all_with</font></strong> element:<font color="#008000">E</font> <-
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">replace_all</font></strong> old_value:<font color="#008000">E</font> <strong><font color="#0000FF">with</font></strong> new_value:<font color="#008000">E</font> <-
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">fast_replace_all</font></strong> old_value:<font color="#008000">E</font> <strong><font color="#0000FF">with</font></strong> new_value:<font color="#008000">E</font> <-
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">sub_collection3</font></strong> (line_min, column_min, depth_min:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) 
  <strong><font color="#0000FF">to</font></strong> (line_max, column_max, depth_max:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) :<font color="#008000">SELF</font> <-
    
  <br><font FACE="Sans-serif" color="#000000"><B></B></font>
  <br><font FACE="Sans-serif" color="#000000"><B> Looking and comparison:</B></font>
  <br><font FACE="Sans-serif" color="#000000"><B></B></font>
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">occurrences</font></strong> elt:<font color="#008000">E</font> :<a href="INTEGER.html"><font color="#008000">INTEGER</font></a> <-
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">fast_occurrences</font></strong> elt:<font color="#008000">E</font> :<a href="INTEGER.html"><font color="#008000">INTEGER</font></a> <-
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">has</font></strong> x:<font color="#008000">E</font> :<a href="BOOLEAN.html"><font color="#008000">BOOLEAN</font></a> <-
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp Search if a element x is in the array using `equal'.</font></strong></em>
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp See also `fast_has' to choose the apropriate one.</font></strong></em>
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">fast_has</font></strong> x:<font color="#008000">E</font> :<a href="BOOLEAN.html"><font color="#008000">BOOLEAN</font></a> <-
  <br><em><strong><font color="#707070">&nbsp &nbsp &nbsp &nbsp  Search if a element x is in the array using `='.</font></strong></em>
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">all_default</font></strong>:<a href="BOOLEAN.html"><font color="#008000">BOOLEAN</font></a> <-
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">swap</font></strong> (line1, column1, depth1:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) <strong><font color="#0000FF">with</font></strong> (line2, column2, depth2:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a>) <-
      
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">copy</font></strong> other:<font color="#008000">SELF</font> <-
    
  <br><font FACE="Sans-serif" color="#000000"><B></B></font>
  <br><font FACE="Sans-serif" color="#000000"><B> Invariant.</B></font>
  <br><font FACE="Sans-serif" color="#000000"><B></B></font>
  
<br><font FACE="Sans-serif" color="#000000"><B>  [ ...</B></font>
<br><font FACE="Sans-serif" color="#000000"><B>    -? { count1 = upper1 - lower1 + 1 };</B></font>
<br><font FACE="Sans-serif" color="#000000"><B>    -? { count2 = upper2 - lower2 + 1 };</B></font>
<br><font FACE="Sans-serif" color="#000000"><B>    -? { count3 = upper3 - lower3 + 1 };</B></font>
<br><font FACE="Sans-serif" color="#000000"><B>    -? { capacity >= count };</B></font>
<br><font FACE="Sans-serif" color="#000000"><B>  ];</B></font>
  
  

</body>
</html>
 